<?
function obtwit_calcDiffsForUft($twit_date,$curr_date) {

	$diff_info = array();
	
	$diff_info['twitstamp'] = $twit_date; $diff_info['currstamp'] = $curr_date;
	
	if ( (strlen($diff_info['twitstamp']) > 0) && (strlen($diff_info['currstamp']) > 0) ) {
	
		$diff = $diff_info['currstamp'] - $diff_info['twitstamp'];
		
		if ( $days	= intval((floor($diff/86400))))	$diff = $diff % 86400;
		if ( $hours	= intval((floor($diff/3600)))) 	$diff = $diff % 3600;
		if ( $mins	= intval((floor($diff/60))))	$diff = $diff % 60;
			 $secs 	= intval($diff);
		
		$diff_info['days'] = $days; $diff_info['hours'] = $hours;
		$diff_info['mins'] = $mins; $diff_info['secs'] = $secs;
		
		return $diff_info; 
	
	} else {
		return $error = true;
	}
	
	$diff_info = ''; $diff = ''; $days = ''; $hours = ''; $mins = ''; $secs = '';

}


function obtwit_formatUfTime($twit_date,$curr_date) {

	$data = obtwit_calcDiffsForUft($twit_date,$curr_date);
	
	if ( $data['days'] == 0 ) {
		if ( $data['hours'] == 0 ) {
			if ( ($data['mins'] == 0) || ($data['mins'] == 1) ) { 
				$uft .= '1 minute ago';
			} else { 
				$uft .= $data['mins'].' minutes ago';
			}
		} else { 
			if ( $data['hours'] == 1 ) { 
				$uft .= '1 hour ago'; 
			} else { 
				$uft .= $data['hours'].' hours ago';
			}
		}
		
	} else {
		if ( $data['days'] == 1 ) {
			$uft .= '1 day ago';
		} else if ( $data['days'] < 7) {
			$uft .= $data['days'].' days ago';
		} else $uft .= date("M jS", $twit_date-10800);
	}
	
	return $uft;
	
	$data = ''; $uft = ''; $twit_date = ''; $curr_date = '';
}

function obtwit_linkify($text) {
    $url_pattern = '/# Rev:20100913_0900 github.com\/jmrware\/LinkifyURL
    # Match http & ftp URL that is not already linkified.
      # Alternative 1: URL delimited by (parentheses).
      (\()                     # $1  "(" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $2: URL.
      (\))                     # $3: ")" end delimiter.
    | # Alternative 2: URL delimited by [square brackets].
      (\[)                     # $4: "[" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $5: URL.
      (\])                     # $6: "]" end delimiter.
    | # Alternative 3: URL delimited by {curly braces}.
      (\{)                     # $7: "{" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $8: URL.
      (\})                     # $9: "}" end delimiter.
    | # Alternative 4: URL delimited by <angle brackets>.
      (<|&(?:lt|\#60|\#x3c);)  # $10: "<" start delimiter (or HTML entity).
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $11: URL.
      (>|&(?:gt|\#62|\#x3e);)  # $12: ">" end delimiter (or HTML entity).
    | # Alternative 5: URL not delimited by (), [], {} or <>.
      (                        # $13: Prefix proving URL not already linked.
        (?: ^                  # Can be a beginning of line or string, or
        | [^=\s\'"\]]          # a non-"=", non-quote, non-"]", followed by
        ) \s*[\'"]?            # optional whitespace and optional quote;
      | [^=\s]\s+              # or... a non-equals sign followed by whitespace.
      )                        # End $13. Non-prelinkified-proof prefix.
      ( \b                     # $14: Other non-delimited URL.
        (?:ht|f)tps?:\/\/      # Required literal http, https, ftp or ftps prefix.
        [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]+ # All URI chars except "&" (normal*).
        (?:                    # Either on a "&" or at the end of URI.
          (?!                  # Allow a "&" char only if not start of an...
            &(?:gt|\#0*62|\#x0*3e);                  # HTML ">" entity, or
          | &(?:amp|apos|quot|\#0*3[49]|\#x0*2[27]); # a [&\'"] entity if
            [.!&\',:?;]?        # followed by optional punctuation then
            (?:[^a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]|$)  # a non-URI char or EOS.
          ) &                  # If neg-assertion true, match "&" (special).
          [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]* # More non-& URI chars (normal*).
        )*                     # Unroll-the-loop (special normal*)*.
        [a-z0-9\-_~$()*+=\/#[\]@%]  # Last char can\'t be [.!&\',;:?]
      )                        # End $14. Other non-delimited URL.
    /imx';
    $url_replace = '$1$4$7$10$13<a rel="nofollow" href="$2$5$8$11$14">$2$5$8$11$14</a>$3$6$9$12';
    return preg_replace($url_pattern, $url_replace, $text);
}
function obtwit_linkify_html($text) {
    $text = preg_replace('/&apos;/', '&#39;', $text); // IE does not handle &apos; entity!
    $section_html_pattern = '%# Rev:20100913_0900 github.com/jmrware/LinkifyURL
    # Section text into HTML <A> tags  and everything else.
      (                              # $1: Everything not HTML <A> tag.
        [^<]+(?:(?!<a\b)<[^<]*)*     # non A tag stuff starting with non-"<".
      |      (?:(?!<a\b)<[^<]*)+     # non A tag stuff starting with "<".
      )                              # End $1.
    | (                              # $2: HTML <A...>...</A> tag.
        <a\b[^>]*>                   # <A...> opening tag.
        [^<]*(?:(?!</a\b)<[^<]*)*    # A tag contents.
        </a\s*>                      # </A> closing tag.
      )                              # End $2:
    %ix';
    return preg_replace_callback($section_html_pattern, '_obtwit_linkify_html_callback', $text);
}
function _obtwit_linkify_html_callback($matches) {
    if (isset($matches[2])) return $matches[2];
    return obtwit_linkify($matches[1]);
}


function obtwit_makeClickableLinks($text) {

 $text = obtwit_linkify_html($text);

$text = preg_replace('#@([A-Za-z0-9_]+)#', '<a rel="nofollow" href="http://www.twitter.com/\1">\0</a> ', $text);
$text = preg_replace('~#([A-Za-z0-9_]+)~','<a rel="nofollow" href="https://twitter.com/search?q=%23\1">\0</a> ', $text); 

return $text;
}
?>