<?php

/*

VERSION HISTORY
1.0		1/22/03		Updated hasExt() to use pathinfo()
1.1		1/22/03		Added relPath() and split up file into sections
1.2		1/22/03		Added flashFormat()
2.0		12/25/07	Reduced to CMS2

*/

# --------------------------------------
# ENABLERS
# --------------------------------------

#If register global vars is off
if (ini_get('register_globals') != 1) {
    $supers = array('_REQUEST','_ENV','_SERVER');
    foreach ($supers as $__s) {
        if (is_array($$__s) == true) extract($$__s, EXTR_OVERWRITE);
    }
    unset($supers);
}

function self(){
	return "http://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
}

function open_form($name="cms_form",$onSubmit=""){
return "<form method=\"post\" enctype=\"multipart/form-data\" id=\"".$name."\" name=\"".$name."\" onSubmit=\"".$onSubmit."\">";

}
function mWidth($ems=-1,$canScroll=false){
if($ems==-1)$ems=$_SESSION['default_ms'];
$scrollBarWidth=($canScroll)? 18 : 2;
return "width:".(($ems*8)+$scrollBarWidth)."px;";  //determines approx width in lowercase m's for cms font size.
}
function close_form(){
return "</form>";
}

function requiredNote(){
return "<div class=\"label_required\" style=\"text-align:right;\">* Required</div>";
}
function label($str,$required=false){
if($required) $str= "<div class=\"label_required\">".ucwords(strtolower($str))."</div>";
else $str= "<div class=\"label\">".ucwords(strtolower($str))."</div>";
return str_replace('Cm2', 'CM2', $str);

}
function header_label($str){
return "<div class=\"header\">".ucwords(strtolower($str))."</div>".horz();

}
function title($str,$len=80){
$str=strip_tags($str);
if(strlen($str)>$len)$str=substr_replace($str,'...',$len);
return '<span class="title">'.htmlentities($str).'</span>';
}
function deleteIt($pid){
 $str='';
 if($_GET['page_sub']) $str.= '<input type="hidden" name="page_sub" value="'.$_GET['page_sub'].'" />';  
 if($_GET['groupID']) $str.= '<input type="hidden" name="groupID" value="'.$_GET['groupID'].'" />';
return open_form("deleteIt","return confirm('Are you sure you want to delete?');").'<input type="hidden" name="PID" value="'.$pid.'"/>'.$str.'<input type="submit" name="submitDelete" value="Delete" />'.close_form();
}
function addIt($height=null,$width=null){
$str="";
if($height)$str.=",".$height;
if($width)$str.=",".$width;
return '<form><input type="button" value="Add New" onClick="openID(\'addNew_cms\''.$str.')"/></form>';
}
function spacer($num=10){
	return '<div style="clear:both; height:'.$num.'px; line-height:0px; font-size:0px;"><!-- --></div>';
}
function horz(){
	return '<div class="hr"><!-- --></div>';
}
function horz_light(){
	return '<div class="hrlight"><!-- --></div>';
}
function back($groupID=0,$page_sub=1){
if($_GET['back_sub'])$page_sub=$_GET['back_sub'];
if($_GET['back_sub']===false)$groupID=0;
if($groupID)return '<form><input type="button" value="Go Back" onClick="window.location.href=\'main.php?page='.$_GET['page'].'&groupID='.$groupID.'&page_sub='.$page_sub.'\'"/></form>';
return '<form><input type="button" value="Go Back" onClick="window.location.href=\'main.php?page='.$_GET['page'].'\'"/></form>';
}
#email safe guard
function has_no_emailheaders($text) 
{ 
   if(preg_match("/(%0A|%0D|\\n+|\\r+)(content-type:|to:|cc:|bcc:)/i", $text) == 0) return $text;
   else return "Text Blocked";
} 
function parseYouTube($yturl,$html=false){//returns link to flash player
	$url= explode("&",$yturl);
	if(stripos($url[0],'imeo')){
		$temp = explode('/',str_replace(array('http://'),array(''),$url[0]));
		return $temp[1];
	}
	/*if($html){
		$repl = array('watch?','=');
		$withthis = array('','/');
		return str_replace($repl,$withthis,$url[0]);
	}*/
	$temp = explode("watch?v=",$url[0]);
	return $temp[1];
}
function linkType($n,$id=null,$sel_protocol='http://'){
if($id==null)$id=$n;
$output = '<select name="'.$n.'" id="'.$id.'" class="linkType">';
   $avail_protocols = explode(",",$_SESSION['link_protocols']); 	      
   foreach($avail_protocols as $protocol) {  
   		$sel="";
		if($sel_protocol==$protocol)$sel="selected";
		$output.= '<option '.$sel.' value="'.$protocol.'" id="'.$id.'_'.$protocol.'">'.$protocol.'</option>';
   }    
$output.= '</select>';
return $output;
}
function convert_word_to_ascii($string) 
{
    $string = stripslashes($string);
    
   $search = array(chr(145),
                chr(146), 
                chr(96),
				chr(139), 
                chr(155),
                chr(132),
                chr(147),
                chr(148),
                chr(133),
                chr(150),
				chr(151)); 
        
    $replace = array(    "'",
                "'",
                "'",
				"'",
                "'",
                '"',
                '"',
                '"',
                '...',
                '-',
				'-'); 

    $new_string = str_replace($search, $replace, $string);
    return addslashes($new_string);
};

function scriptSafe($str){
	$order   = array("\r\n", "\n", "\r");
	$replace = array('\r\n','\n','\r');
	return "'".str_replace($order, $replace, addslashes(htmlspecialchars($str)))."'";
}

function deleteOrdered($table,$PID){
	$row = @mysql_fetch_array(@mysql_query("SELECT * FROM $table WHERE id='$PID'"));
	$orderby=$row['orderby'];
	$numRows = @mysql_num_rows(@mysql_query("SELECT * FROM $table WHERE groupid=$PID"))+1;//group plus PID
	@mysql_query("DELETE FROM $table WHERE id='$PID' OR groupid='$PID'");
	@mysql_query("UPDATE $table SET orderby=orderby-$numRows WHERE orderby>".$orderby);
	return $orderby;
}
function deleteDateOrdered($table,$PID){
	$row = @mysql_fetch_array(@mysql_query("SELECT * FROM $table WHERE id='$PID'"));
	$date=$row['date'];
	$orderby=$row['orderby'];
	@mysql_query("DELETE FROM $table WHERE id='$PID'");
	@mysql_query("UPDATE $table SET orderby=orderby-1 WHERE date=".sqlFormat($date)." AND orderby>".$orderby);
	return $orderby;
}
function deleteFile($table,$PID){
	$result = @mysql_query("SELECT * FROM $table,fileDB WHERE fid=fileid AND id=".$PID);
	$row = @mysql_fetch_array($result);
	if($row['fileid']!=1){
	 	@mysql_query("DELETE FROM fileDB WHERE fid=".$row['fileid']);
		if($row['ext']){
			@unlink('../FDB/'.$row['fid'].'.'.$row['ext']);	//delete the actual file
			foreach(glob('../FDB/'.$row['fid'].'_*.'.$row['ext']) as $fn) { 
				@unlink($fn); 
			}
		} 
	 	
	}
}
function getFileID(){
	@mysql_query("INSERT fileDB SET error='No File'");
	return @mysql_insert_id();
}
function changeStatus($status,$id,$table){

	$result = @mysql_query("SELECT * FROM $table,fileDB WHERE fid=fileid AND id=".$id);
	$row = @mysql_fetch_array($result);
	if($status==0||$row['error']){	
		if($row['error']){
			@mysql_query("UPDATE $table SET status=0 WHERE id=".$id);
			return "Incomplete";
		}else{
			$status=2;
			@mysql_query("UPDATE $table SET status=$status WHERE id=".$id);
		}
	}
	$output.='<select name="status'.$id.'" id="status'.$id.'" onChange="updateStatus(this,'.$id.')">';
	if($status==-1)$output.='<option value="-1" selected>Disabled</option>';
	else $output.='<option value="-1">Disabled</option>';
	if($status==2)$output.='<option value="2" selected>Preview</option>';
	else $output.='<option value="2">Preview</option>';
	if($status==1)$output.='<option value="1" selected>Live</option>';
	else $output.='<option value="1">Live</option>';	
	$output.='</select>';
	return $output;

}
#for putting text into mysql
function sqlFormat($text) {
	$text = convert_word_to_ascii($text);
	$text = trim($text);
	while (stripslashes($text) != $text) {
		$text = stripslashes($text);
	}
	$text = addslashes($text);
	if ($text == "") $text = 'null';
	else $text = "'$text'";
	return $text;
}
/*
function htmlFormat($str) {
	$repl = array('<a ','<a target="_blank" href="mailto','<a target="_blank" href="CM2_Keyword:','<a target="_blank" href="CM2_Email:',"\r\n","<bold>","</bold>","<ital>","</ital>","<t>","</t>","©");
	$withthis = array('<a target="_blank" ','<a target="_self" href="mailto','<A href="/','<a href="mailto:',"<br>","<b>","</b>","<i>","</i>","<h2>","</h2>","&copy;");
	return str_replace($repl,$withthis,$str);
}
*/
class FlashFormat{
	var $total=0;
	var $output;
	function add(){
		$this->total++;
	}
	function addVal($name,$val,$uppercase=false){
		$this->output.=$name.($this->total-1).'='.$this->format($val,$uppercase).'&';
	}
	function addCustom($name,$val,$uppercase=false){
		$this->output.=$name.'='.$this->format($val,$uppercase).'&';
	}
	function query($query_str){
		$result = @mysql_query($query_str);
		while ($row = @mysql_fetch_array($result)) {
			$this->add();
			foreach($row as $key=>$val){
				if(!is_numeric($key))$this->addVal($key,$val);
			}
		}
	
	}
	function output(){
		$this->output.='total='.$this->total;
		return $this->output;
	}
	function format($str,$uppercase=false) {
	$repl = array('<a ','<a target="_blank" href="mailto','<a target="_blank" href="CM2_Keyword:','<a target="_blank" href="CM2_Email:',"\r\n");
	$withthis = array('<a target="_blank" ','<a target="_self" href="mailto','<a href="asfunction:CM2_Keyword,','<a href="asfunction:CM2_Email,',"\r");
	/*$avail_tags = explode(",",$_SESSION['tags_avail']);
    foreach($avail_tags as $tag) {
		array_push($repl,"<".$tag.">","</".$tag.">");
		array_push($withthis,$_SESSION[$tag.'_start_tag'],$_SESSION[$tag.'_end_tag']);
 	} */
	if($uppercase=='true'){
	    return strtoupper(urlencode(str_replace($repl,$withthis,$str)));
		//rawurlencode(utf8_encode( for utf8 sites
	}
	else return urlencode(str_replace($repl,$withthis,$str));
}
}


/*    CALL FlashFormat::format for one-offs
#echo to flash
function flashFormat($str,$uppercase=false) {
	$repl = array('</a>','<a ','<a target="_blank" href="mailto',"\r\n");
	$withthis = array('</a></u></font>','<font color="'+$link_color+'"><u><a target="_blank" ','<font color="'+$link_color+'"><a target="_self" href="mailto',"\r");
	$avail_tags = explode(",",$_SESSION['tags_avail']);
    foreach($avail_tags as $tag) {
		array_push($repl,"<".$tag.">","</".$tag.">");
		array_push($withthis,$_SESSION[$tag.'_start_tag'],$_SESSION[$tag.'_end_tag']);
 	} 
	if($uppercase=='true'){
	    return strtoupper(urlencode(str_replace($repl,$withthis,$str)));
	}
	else return urlencode(str_replace($repl,$withthis,$str));
}
*/
# --------------------------------------
# MYSQL
# --------------------------------------

function if_not_create($table,$columns){
	$res = mysql_query("show table status like '$table'")
	or die(mysql_error());
	if(!mysql_num_rows($res)){
		mysql_query("CREATE TABLE $table (id INT NOT NULL AUTO_INCREMENT PRIMARY KEY, $columns) ENGINE = MYISAM");
		mysql_error();
		return true;
	}
	return false;
}


# --------------------------------------
# STRINGS
# --------------------------------------

#get rid of non numbers from strings
function justNum($string) {
	$string = ereg_replace("[^[:digit:]]","",$string);
	return $string;
}

#adds zeros to begining up to 2 digits (usefull for days, months, hours, etc)
function pad2($num) {
	return str_pad($num,2,"0",STR_PAD_LEFT);
}

function remove_protocol($url){
	if($url){
		return ereg_replace("^(http://)|(https://)|(ftp://)","",$url);
	}
}

#add http to a url
function url($url) {
	if ($url) if (!eregi("^(http://)|(https://)|(ftp://)",$url)) $url = 'http://'.$url;
	return $url;
}

function checkEmail($str){
  // check an email address is possibly valid
  if(!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$",  $str))
    return false;
  else 
    return true;
}

#format a filesize
function sizeFormat($size) {
	$suf = " bytes";
	$size = round($size,0);
	if ($size > 1024) {
		$size /= 1024;
		$suf = " k";
		$size = round($size,0);
	}
	if ($size > 1024) {
		$size /= 1024;
		$suf = " mb";
		$size = round($size,1);
	}
	if (!$size) {
		$size = 'error';
		$suf = '';
	}
	return $size.$suf;
}

#convert pasted html enteties to html
function pasteEntities($text) {
	$text = str_replace('&apos;','\'',$text);
	return $text;
}

# --------------------------------------
# FILESYSTEM
# --------------------------------------

#make sure a file is uploaded
function checkUpload($filename,$filename_size) {
	if ($filename == "none") return false;
	elseif ($filename_size == 0) return false;
	elseif (!is_uploaded_file($filename)) return false;
	else return true;
}

#get filename and extension
function fileNameSplit($name) {
	$pos = strrpos($name,'.');
	$beg = substr($name,0,$pos);
	$ext = substr($name,$pos+1);
	return array($beg,$ext);
}

#verify that extension exists
function hasExt($name,$exts) {
	$parts = pathinfo($name);
	$ext   = $parts['extension'];
	for ($i=0; $i<count($exts); $i++) {
		if ($exts[$i] == $ext) return true;
	}
	return false;
}

#save a file in a particular directory with a unique name
function saveFile($file,$name,$dir) {

	list($beg,$ext) = fileNameSplit($name);
	//$beg = ereg_replace('[^[:alpha:]]','',$beg);
	
	#see if file exists and update name
	while (file_exists($dir.$beg.$i.'.'.$ext)) {
		$i++;
	}
	
	#save file
	$name = $beg.$i.'.'.$ext;
	$path = $dir.$name;
	copy($file,$path);
	
	#exit
	return $name;
}

#convert a realPath to something relative to the www directory
function relPath($path,$dir='htdocs') {
	return substr($path,strpos($path,$dir)+strlen($dir));
}


/*****************************************************************/

#maintains aspect ration and fits inside the maxWidth and maxHeight
function resizeJPG($image,$maxW,$maxH,$target=null) {
	$quality=90;
	if($_SESSION['image_quality'])$quality=$_SESSION['image_quality'];
	#get dimensions
	$size = GetImageSize($image);
	$nowW = $size[0];
	$nowH = $size[1];
	
	if($nowW<$maxW&&$nowH<$maxH&&$target){
		$maxW=$nowW;
		$maxH=$nowH;
	}
	
	#get ratios
	$ratioX = $maxW / $nowW;
	$ratioY = $maxH / $nowH;

	#figure out new dimensions
	if (($nowW <= $maxW) && ($nowH <= $maxH)) {
		$newW = $nowW;
		$newH = $nowH;
	} else if (($ratioX * $nowH) < $maxH) {
		$newW = $maxW;
		$newH = ceil($ratioX * $nowH);
	} else {
		$newW = ceil($ratioY * $nowW);
		$newH = $maxH;
	}

	#do processing
	$src = ImageCreateFromJpeg($image);
	$dst = imageCreateTrueColor($newW,$newH);
	ImageCopyResampled($dst,$src,0,0,0,0,$newW,$newH,$nowW,$nowH);

	#output
	if ($target != null) {
		ImageJpeg($dst,$target,$quality);
	} else {
		header("Content-type:image/jpeg");
		ImageJpeg($dst,null,$quality);
	}

	#cleanup
	ImageDestroy($src);
	ImageDestroy($dst);
	return true;
}

#maintains aspect ratio, resizes so first dimension equals the max size
function min_resizeJPG($image,$maxW,$maxH,$target=null) {
	$quality=90;
	if($_SESSION['image_quality'])$quality=$_SESSION['image_quality'];
	#get dimensions
	$size = GetImageSize($image);
	$nowW = $size[0];
	$nowH = $size[1];

	#get ratios
	$ratioX = $maxW / $nowW;
	$ratioY = $maxH / $nowH;

	#figure out new dimensions
	if (($nowW == $maxW) && ($nowH == $maxH)) {
		$newW = $nowW;
		$newH = $nowH;
	} else if (($ratioX * $nowH) > $maxH) {
		$newW = $maxW;
		$newH = ceil($ratioX * $nowH);
	} else {
		$newW = ceil($ratioY * $nowW);
		$newH = $maxH;
	}


	#do processing
	$src = ImageCreateFromJpeg($image);
	$dst = imageCreateTrueColor($newW,$newH);
	ImageCopyResampled($dst,$src,0,0,0,0,$newW,$newH,$nowW,$nowH);

	#output
	if ($target != null) {
		ImageJpeg($dst,$target,$quality);
	} else {
		header("Content-type:image/jpeg");
		ImageJpeg($dst,null,$quality);
	}

	#cleanup
	ImageDestroy($src);
	ImageDestroy($dst);
	return true;
}

#maintains aspect ration, resizes down to a given width
function width_resizeJPG($image,$maxW,$target=null) {
	$quality=90;
	if($_SESSION['image_quality'])$quality=$_SESSION['image_quality'];
	#get dimensions
	$size = GetImageSize($image);
	$nowW = $size[0];
	$nowH = $size[1];

	#get ratios
	$ratioX = $maxW / $nowW;

	$newW = $maxW;
	$newH = ceil($ratioX * $nowH);

	#do processing
	$src = ImageCreateFromJpeg($image);
	$dst = imageCreateTrueColor($newW,$newH);
	ImageCopyResampled($dst,$src,0,0,0,0,$newW,$newH,$nowW,$nowH);

	#output
	if ($target != null) {
		ImageJpeg($dst,$target,$quality);
	} else {
		header("Content-type:image/jpeg");
		ImageJpeg($dst,null,$quality);
	}

	#cleanup
	ImageDestroy($src);
	ImageDestroy($dst);
	return true;
}
#maintains aspect ration, resizes down to a given width
function height_resizeJPG($image,$maxH,$target=null) {
	$quality=90;
	if($_SESSION['image_quality'])$quality=$_SESSION['image_quality'];
	#get dimensions
	$size = GetImageSize($image);
	$nowW = $size[0];
	$nowH = $size[1];

	#get ratios
	$ratioY = $maxH / $nowH;

	$newH = $maxH;
	$newW = ceil($ratioY * $nowW);

	#do processing
	$src = ImageCreateFromJpeg($image);
	$dst = imageCreateTrueColor($newW,$newH);
	ImageCopyResampled($dst,$src,0,0,0,0,$newW,$newH,$nowW,$nowH);

	#output
	if ($target != null) {
		ImageJpeg($dst,$target,$quality);
	} else {
		header("Content-type:image/jpeg");
		ImageJpeg($dst,null,$quality);
	}

	#cleanup
	ImageDestroy($src);
	ImageDestroy($dst);
	return true;
}
function crop_centerJPG($image,$maxW,$maxH,$target=null) {
	$quality=90;
	if($_SESSION['image_quality'])$quality=$_SESSION['image_quality'];
	#get dimensions
	$size = GetImageSize($image);
	$nowW = $size[0];
	$nowH = $size[1];

	$start_y=($nowH-$maxH)/2;
	$start_x=($nowW-$maxW)/2;

	$end_y=$nowH-$maxH;
	$end_x=$nowW-$maxW;

	#do processing
	$src = ImageCreateFromJpeg($image);
	$dst = imageCreateTrueColor($maxW,$maxH);
	ImageCopyResampled($dst,$src,0,0,$start_x,$start_y,$maxW,$maxH,$maxW,$maxH);

	#output
	if ($target != null) {
		ImageJpeg($dst,$target,$quality);
	} else {
		header("Content-type:image/jpeg");
		ImageJpeg($dst,null,$quality);
	}

	#cleanup
	ImageDestroy($src);
	ImageDestroy($dst);
	return true;
}

#resize an image and then crop the center out
function resizeAndCropCenter($image,$dstW,$dstH,$target=null) {
	$quality=90;
	if($_SESSION['image_quality'])$quality=$_SESSION['image_quality'];
	#get dimensions
	$size = GetImageSize($image);
	$srcW = $size[0];
	$srcH = $size[1];

	#get ratios
	$ratioX = $dstW / $srcW;
	$ratioY = $dstH / $srcH;

	#make sure there isn't enlarging required
//	if (($ratioX > 1)||($ratioY >1)) exit('Source photo is too small');

	#figure out source points
	if ($ratioX < $ratioY) { #long photo
		$srcX = round(($srcW - ($dstW / $ratioY))/2);
		$srcY = 0;
		$srcW = round($dstW / $ratioY);
		$srcH = $srcH;
	} else { #tall photo
		$srcX = 0;
		$srcY = round(($srcH - ($dstH / $ratioX))/2);
		$srcW = $srcW;
		$srcH = round($dstH / $ratioX);
	}

	#do processing
	$src = ImageCreateFromJpeg($image);
	$dst = imageCreateTrueColor($dstW,$dstH);
	ImageCopyResampled($dst,$src,0,0,$srcX,$srcY,$dstW,$dstH,$srcW,$srcH);

	#output
	if ($target != null) {
		ImageJpeg($dst,$target,$quality);
	} else {
		header("Content-type:image/jpeg");
		ImageJpeg($dst,null,$quality);
	}

	#cleanup
	ImageDestroy($src);
	ImageDestroy($dst);
	return true;


}

function calcDiffsForUft($twit_date,$curr_date) {

	$diff_info = array();
	
	$diff_info['twitstamp'] = $twit_date; $diff_info['currstamp'] = $curr_date;
	
	if ( (strlen($diff_info['twitstamp']) > 0) && (strlen($diff_info['currstamp']) > 0) ) {
	
		$diff = $diff_info['currstamp'] - $diff_info['twitstamp'];
		
		if ( $days	= intval((floor($diff/86400))))	$diff = $diff % 86400;
		if ( $hours	= intval((floor($diff/3600)))) 	$diff = $diff % 3600;
		if ( $mins	= intval((floor($diff/60))))	$diff = $diff % 60;
			 $secs 	= intval($diff);
		
		$diff_info['days'] = $days; $diff_info['hours'] = $hours;
		$diff_info['mins'] = $mins; $diff_info['secs'] = $secs;
		
		return $diff_info; 
	
	} else {
		return $error = true;
	}
	
	$diff_info = ''; $diff = ''; $days = ''; $hours = ''; $mins = ''; $secs = '';

}


function formatUfTime($twit_date,$curr_date) {

	$data = calcDiffsForUft($twit_date,$curr_date);
	
	if ( $data['days'] == 0 ) {
		if ( $data['hours'] == 0 ) {
			if ( ($data['mins'] == 0) || ($data['mins'] == 1) ) { 
				$uft .= '1 minute ago';
			} else { 
				$uft .= $data['mins'].' minutes ago';
			}
		} else { 
			if ( $data['hours'] == 1 ) { 
				$uft .= '1 hour ago'; 
			} else { 
				$uft .= $data['hours'].' hours ago';
			}
		}
		
	} else {
		$uft .= date("g:i A M jS", $twit_date-10800);
	}
	
	return $uft;
	
	$data = ''; $uft = ''; $twit_date = ''; $curr_date = '';
}

function linkify($text) {
    $url_pattern = '/# Rev:20100913_0900 github.com\/jmrware\/LinkifyURL
    # Match http & ftp URL that is not already linkified.
      # Alternative 1: URL delimited by (parentheses).
      (\()                     # $1  "(" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $2: URL.
      (\))                     # $3: ")" end delimiter.
    | # Alternative 2: URL delimited by [square brackets].
      (\[)                     # $4: "[" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $5: URL.
      (\])                     # $6: "]" end delimiter.
    | # Alternative 3: URL delimited by {curly braces}.
      (\{)                     # $7: "{" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $8: URL.
      (\})                     # $9: "}" end delimiter.
    | # Alternative 4: URL delimited by <angle brackets>.
      (<|&(?:lt|\#60|\#x3c);)  # $10: "<" start delimiter (or HTML entity).
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $11: URL.
      (>|&(?:gt|\#62|\#x3e);)  # $12: ">" end delimiter (or HTML entity).
    | # Alternative 5: URL not delimited by (), [], {} or <>.
      (                        # $13: Prefix proving URL not already linked.
        (?: ^                  # Can be a beginning of line or string, or
        | [^=\s\'"\]]          # a non-"=", non-quote, non-"]", followed by
        ) \s*[\'"]?            # optional whitespace and optional quote;
      | [^=\s]\s+              # or... a non-equals sign followed by whitespace.
      )                        # End $13. Non-prelinkified-proof prefix.
      ( \b                     # $14: Other non-delimited URL.
        (?:ht|f)tps?:\/\/      # Required literal http, https, ftp or ftps prefix.
        [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]+ # All URI chars except "&" (normal*).
        (?:                    # Either on a "&" or at the end of URI.
          (?!                  # Allow a "&" char only if not start of an...
            &(?:gt|\#0*62|\#x0*3e);                  # HTML ">" entity, or
          | &(?:amp|apos|quot|\#0*3[49]|\#x0*2[27]); # a [&\'"] entity if
            [.!&\',:?;]?        # followed by optional punctuation then
            (?:[^a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]|$)  # a non-URI char or EOS.
          ) &                  # If neg-assertion true, match "&" (special).
          [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]* # More non-& URI chars (normal*).
        )*                     # Unroll-the-loop (special normal*)*.
        [a-z0-9\-_~$()*+=\/#[\]@%]  # Last char can\'t be [.!&\',;:?]
      )                        # End $14. Other non-delimited URL.
    /imx';
    $url_replace = '$1$4$7$10$13<a rel="nofollow" href="$2$5$8$11$14">$2$5$8$11$14</a>$3$6$9$12';
    return preg_replace($url_pattern, $url_replace, $text);
}
function linkify_html($text) {
    $text = preg_replace('/&apos;/', '&#39;', $text); // IE does not handle &apos; entity!
    $section_html_pattern = '%# Rev:20100913_0900 github.com/jmrware/LinkifyURL
    # Section text into HTML <A> tags  and everything else.
      (                              # $1: Everything not HTML <A> tag.
        [^<]+(?:(?!<a\b)<[^<]*)*     # non A tag stuff starting with non-"<".
      |      (?:(?!<a\b)<[^<]*)+     # non A tag stuff starting with "<".
      )                              # End $1.
    | (                              # $2: HTML <A...>...</A> tag.
        <a\b[^>]*>                   # <A...> opening tag.
        [^<]*(?:(?!</a\b)<[^<]*)*    # A tag contents.
        </a\s*>                      # </A> closing tag.
      )                              # End $2:
    %ix';
    return preg_replace_callback($section_html_pattern, '_linkify_html_callback', $text);
}
function _linkify_html_callback($matches) {
    if (isset($matches[2])) return $matches[2];
    return linkify($matches[1]);
}


function makeClickableLinks($text) {

 $text = linkify_html($text);

$text = preg_replace('#@([a-z0-9_]+)#', '<a rel="nofollow" href="http://www.twitter.com/\1">\0</a> ', $text);
$text = preg_replace('~#([a-z0-9_]+)~','<a rel="nofollow" href="https://twitter.com/search?q=%23\1">\0</a> ', $text); 

return $text;
}


?>