<?
class CMS_Element{
	var $type=0;
	var $name;
	var $required;
	var $column;
	var $height=10;
	var $width=0;
	var $hidden=false;
	
	function CMS_Element($col,$name,$type,$required=false,$width,$height=10,$hidden=false){
		$this->add($col,$name,$type,$required,$width,$height,$hidden);
	}
	function setWidth($w){
		$this->width=$w;
	}
	function setHeight($h){
		$this->height=$h;
	}
	function setHidden($h){
		$this->hidden=$h;	
	}
	function get_element_height(){
		switch($this->type){
			case BODY_ELEMENT:
			case BODY_HTML_ELEMENT:
				return $this->height;
				break;
		}
		return 1;
	}
	function add($col,$name,$type,$required=false,$width,$height=10,$hidden=false){
		$this->column=$col;
		$this->name=$name;
		$this->type=$type;
		$this->required=$required;
		$this->width=$width;
		$this->height=$height;
		$this->hidden=$hidden;
	}
	function getDB(){
		$str='';
		switch($this->type){
			case LINK_ELEMENT:
				$str.=$this->column.'_protocol TEXT NULL,';
			case TITLE_ELEMENT:
			case COLOR_ELEMENT:
			case BODY_ELEMENT:
			case BODY_HTML_ELEMENT:
				$str.=$this->column.' TEXT NULL';
				break;			
			case CHECKBOX_ELEMENT:
				$str.=$this->column.' INT NOT NULL default 0';
				break;		
			case DATE_ELEMENT:
				$str.="`".$this->column."` date NOT NULL default '0000-00-00'";
				break;
		}	
		return $str;
	}
	function form_element($prefix=null,$postfix=null,$row=null){
		if($this->hidden==true){
			echo '<input name="'.$this->column.'" id="'.$prefix.$this->column.$postfix.'" type="hidden" value="'.$row[$this->column].'" />';
			return;
		}
		switch($this->type){
			case LINK_ELEMENT:
				echo label($this->name,$this->required);
				$output='<div class="element">'.linkType($this->column.'_protocol',$prefix.$this->column.'_protocol'.$postfix,$row[$this->column.'_protocol']);
				$output.='&nbsp;<input name="'.$this->column.'" id="'.$prefix.$this->column.$postfix.'" onchange='."'if(document.getElementById(".'"'.$prefix.$this->column.'_protocol'.$postfix.'"'.
				').options[document.getElementById('.'"'.$prefix.$this->column.'_protocol'.$postfix.'"'.').selectedIndex].text=='.
				'"CM2_Keyword:"'.')this.value='.'this.value.replace(/^\s+|\s+$/g,"").replace(/\$|,|\!|\$|@|#|~|`|\%|\*|\"|\^|\&|\(|\)|\+|\=|\[|\]|\}|\{|\;|\:|\<|\>|\?|\||\./g, "_").replace(/ /g,"_").toLowerCase()'."'".' type="text" style="'.mWidth($this->width-14).'" value="'.$row[$this->column].'" /></div>';
				echo $output;
				break;
			case TITLE_ELEMENT:
				echo label($this->name,$this->required);
				echo '<div class="element"><input type="text" id="'.$prefix.$this->column.$postfix.'" name="'.$this->column.'"  style="'.mWidth($this->width).'" value="'.$row[$this->column].'"';
				if($this->column=='urlkeyword'&&$this->name=='Keyword') echo " onchange='".'this.value=this.value.replace(/^\s+|\s+$/g,"").replace(/\$|,|\/|\!|\$|@|#|~|`|\%|\*|\"|\^|\&|\(|\)|\+|\=|\[|\]|\}|\{|\;|\:|\<|\>|\?|\||\./g, "_").replace(/ /g,"_").toLowerCase()'."' "; 		// remove special characters like "$" and "," etc...
				if($this->column=='urlkeyword'&&$this->name=='CM2 Keyword') echo " onchange='".'this.value=this.value.replace(/^\s+|\s+$/g,"").replace(/\$|,|\!|\$|@|#|~|`|\%|\*|\"|\^|\&|\(|\)|\+|\=|\[|\]|\}|\{|\;|\:|\<|\>|\?|\||\./g, "_").replace(/ /g,"_").toLowerCase()'."' "; 		// remove special characters like "$" and "," etc...
				echo ' class="text_input"/></div>';
				break;
			case COLOR_ELEMENT:
				echo label($this->name,$this->required);
				if(isset($row[$this->column])) $val=$row[$this->column];
				else $val='#91908d';
				echo '<div class="element"><input type="color" id="'.$prefix.$this->column.$postfix.'" name="'.$this->column.'"  style="width:100px;" placeholder="#999999" value="'.$val.'" class="text_input color_picker" /></div>';
				break;	
			case BODY_ELEMENT:
				echo label($this->name,$this->required);
				echo '<div class="element"><textarea rows="'.$this->height.'" id="'.$prefix.$this->column.$postfix.'" name="'.$this->column.'"  style="'.mWidth($this->width).'" class="text_input">'.$row[$this->column].'</textarea></div>';
				break;	
			case BODY_HTML_ELEMENT:
				echo label($this->name,$this->required);
				echo '<div class="element"><textarea onselect="enableTagInjector(true,this);" onchange="enableTagInjector(false,this);" rows="'.$this->height.'" id="'.$prefix.$this->column.$postfix.'" name="'.$this->column.'"  style="'.mWidth($this->width).'" class="text_input">'.$row[$this->column].'</textarea></div>';
				break;		
			case CHECKBOX_ELEMENT:
				$str= '<div class="element"><input type="checkbox" id="'.$prefix.$this->column.$postfix.'" name="'.$this->column.'" value="1" ';
				if($row[$this->column]) $str.='checked ';
				$str.='class="text_input"/> '.$this->name.'</div>';
				echo $str;
				break;		
			case DATE_ELEMENT:
				//TODO
				break;
		}		
	}
	
	function onSubmit($prefix=null,$postfix=null){
		if($this->required){
			return "if(document.getElementById('".$prefix.$this->column.$postfix."').value==''){  alert('".strip_tags($this->name)." required');  return false; }; ";
		}
	}
	
	function sql(){
		$sql='';
		if($this->type==LINK_ELEMENT){
			$sql.=$this->column."_protocol=".sqlFormat($_POST[$this->column.'_protocol']).',';
			$_POST[$this->column]=remove_protocol($_POST[$this->column]);
		}
		$sql.=$this->column."=".sqlFormat($_POST[$this->column]);
		return $sql;
	}
	function action($row=''){
		$output='';
		if($this->type==LINK_ELEMENT){
			if($row){
				$output.="'".$row[$this->column.'_protocol']."',";
			}else{
				$output.=$this->column.'_protocol,';
			}
		}
		if($row){
			$order   = array("\r\n", "\n", "\r");
			$replace = array('\r\n','\n','\r');
			$output.="'".str_replace($order, $replace, addslashes(htmlspecialchars($row[$this->column])))."'";
		}
		else{
			$output.= $this->column;
		}
		return $output;
	}
	function update_js($postfix){
		if($this->type==LINK_ELEMENT){ ?>
			document.getElementById('update_<?=$this->column.'_protocol'?>_<?=$postfix?>_'+<?=$this->column.'_protocol'?>).selected=true;
		<? } ?>
		document.getElementById('update_<?=$this->column?>_<?=$postfix?>').value=<?=$this->column ?>;
        <?
	}
}

?>
