<?
if((@include_once('types/CMS_Element.php')) === false)@include_once('../types/CMS_Element.php');
class CMS_Elements{
	var $elements=array();
	var $default=1;
	
	function CMS_Elements($content_name='Title'){
		if(!strlen($content_name))$content_name='Title';
		$this->elements[]= new CMS_Element('text_content',$content_name,TITLE_ELEMENT,true,$_SESSION['default_ms']);
	}
	
	function add($col,$name,$type,$required=false,$width,$height=10,$hidden=false){
		if($this->default){
			$this->default=0;
			$this->elements = array();
		}
		$this->elements[]= new CMS_Element($col,$name,$type,$required,$width,$height,$hidden);
	}
	function setWidth($w){
		foreach($this->elements as $element){
			$element->setWidth($w);
		}
	}
	function setHeight($h){
		foreach($this->elements as $element){
			$element->setHeight($h);
		}
	}
	function getDB(){
		$addDB = array();
		foreach($this->elements as $element){
			$dbElements = explode(",",$element->getDB());
			foreach($dbElements as $dbElement){
				$addDB[]=$dbElement;
			}
		}
		return $addDB;
	}
	
	function sql(){
		$sql="";
		foreach($this->elements as $element){
			if(strlen($sql)>0) $sql.=',';
			$sql.=$element->sql();
		}
		return $sql;
	}
	function sub_dialog($type_name=null,$type_id=1,$page=null,$page_sub=null,$diag_type='sub',$row=null){
		  $onSubmit='';
		  $ukey=0;
            foreach($this->elements as $element){ 
				if($element->column=='urlkeyword'&&$element->name=='Keyword'&&$_SESSION['advseo']){
					$ukey=$row['urlkeyword'];
					$resultukey = mysql_query("SELECT * FROM cmsukeyseo WHERE ukey=".sqlFormat($ukey));
					$rowukey = @mysql_fetch_array($resultukey);			
					$order   = array("\r\n", "\n", "\r");
					$replace = array('\r\n','\n','\r');
					$ukeyleft='<div style="float:left;">';
					$ukeyright='</div><div style="float:right; border-left:solid 1px #999999; width:200px; padding-left:10px;">';
					$ukeyright.=label('SEO tools',false);
					$ukeyright.='<hr/><br/>';
					$ukeyright.=label('Title (max 66)',false);
					$ukeyright.= '<div class="element"><input type="text" id="'.$diag_type.'_'.'ukey_title'.'_'.$type_name.'" name="ukey_title"  style="width:198px" value="'.str_replace($order, $replace, addslashes(htmlspecialchars($rowukey['seo_title']))).'" class="text_input" maxlength="66"/></div>';
					$ukeyright.=label('Description (max 420)',false);
					$ukeyright.= '<div class="element"><textarea id="'.$diag_type.'_'.'ukey_desc'.'_'.$type_name.'" name="ukey_desc" rows="5" cols="30" onchange="if(this.value.length>420){ this.value = this.value.substring(0,420); }" onkeypress="if(this.value.length>420){ this.value = this.value.substring(0,420); } return (this.value.length < 420);" class="text_input">'.str_replace($order, $replace, addslashes(htmlspecialchars($rowukey['seo_desc']))).'</textarea></div>';
					$ukeyright.='<input type="hidden" name="ukeyseo" value="1" />';
					$ukeyright.='</div><div style="clear:both;"><!-- --></div>';
				}
                $onSubmit.=$element->onSubmit($diag_type.'_','_'.$type_name);
            }            
            if(strlen($onSubmit)>0) echo requiredNote();
		  	echo "<form method=\"post\" enctype=\"multipart/form-data\" id=\"".$diag_type.'_'.$type_name."\" name=\"".$diag_type.'_'.$type_name."\" onSubmit=\"".$onSubmit."\" action=\"main.php?page=".$page;
			if($page_sub) echo '&page_sub='.$page_sub; 
			if($_GET['groupID']) echo '&groupID='.$_GET['groupID']; 
            echo "\">";
           echo $ukeyleft;
		  foreach($this->elements as $element){ 
			$element->form_element($diag_type.'_','_'.$type_name,$row);
			}
			
			echo $ukeyright;
			
		    if($page_sub) {?>
            <input type="hidden" name="page_sub" value="<?=$page_sub?>"/>
             <? } ?>
			 <? if($_GET['groupID']) {?>
            <input type="hidden" name="groupID" value="<?=$_GET['groupID']?>"/>
             <? } ?>
            <? if($row['id']){ ?>
            <input type="hidden" name="submitUpdate" value="<?=$type_id?>"/>
            <input type="hidden" name="PID" value="<?=$row['id']?>"/>
            <div style="margin-top:10px;"><input type="submit" name="submit" value="Update"/></div>
            <? } else { ?>
            <input type="hidden" name="submitAdd" value="<?=$type_id?>"/>
            <div style="margin-top:10px;"><input type="submit" name="submit" value="Add New"/></div>
            <? } ?>
            
            <?=close_form();
		
	}
	function addNew_dialog($type_name=null,$type_id=1,$diag_type='addNew'){ ?>
        <div id="<?=$diag_type?>_cms_<?=$type_name?>" class="<?=$diag_type?>_cms" style="display:none;">
        <?
            $onSubmit='';
            foreach($this->elements as $element){ 
				if($element->column=='urlkeyword'&&$element->name=='Keyword'&&$_SESSION['advseo']){
					$ukeyleft='<div style="float:left;">';
					$ukeyright='</div><div style="float:right; border-left:solid 1px #999999; width:200px; padding-left:10px;">';
					$ukeyright.=label('SEO tools',false);
					$ukeyright.='<hr/><br/>';
					$ukeyright.=label('Title (max 66)',false);
					$ukeyright.= '<div class="element"><input type="text" id="'.$diag_type.'_'.'ukey_title'.'_'.$type_name.'" name="ukey_title"  style="width:198px" value="" class="text_input" maxlength="66"/></div>';
					$ukeyright.=label('Description (max 420)',false);
					$ukeyright.= '<div class="element"><textarea id="'.$diag_type.'_'.'ukey_desc'.'_'.$type_name.'" name="ukey_desc" rows="5" cols="30" onchange="if(this.value.length>420){ this.value = this.value.substring(0,420); }" onkeypress="if(this.value.length>420){ this.value = this.value.substring(0,420); } return (this.value.length < 420);" class="text_input"></textarea></div>';
					$ukeyright.='<input type="hidden" name="ukeyseo" value="1" />';
					$ukeyright.='</div><div style="clear:both;"><!-- --></div>';
				}
                $onSubmit.=$element->onSubmit($diag_type.'_','_'.$type_name);
            }            
            if(strlen($onSubmit)>0) echo requiredNote();
           echo open_form($diag_type.'_'.$type_name,$onSubmit);
           echo $ukeyleft;
           ?>
        <? foreach($this->elements as $element){ 
			$element->form_element($diag_type.'_','_'.$type_name);
			}
			
			echo $ukeyright;
			?>
        <input type="hidden" name="submitAdd" value="<?=$type_id?>" />
        <div style="margin-top:10px;"><input type="submit" value="Add New" />&nbsp;<input type="button" value="Cancel" onClick="tb_remove();"/></div>
        <?=close_form();?>
        </div>
    <? }
		
	function update_dialog($type_name=null,$type_id=1,$diag_type='update',$row=null){ ?>
		       <div id="<?=$diag_type?>_cms_<?=$type_name?>" class="<?=$diag_type?>_cms" style="display:none;">
        <?
            $onSubmit='';
            foreach($this->elements as $element){ 
				if($element->column=='urlkeyword'&&$element->name=='Keyword'&&$_SESSION['advseo']){
					$ukeyleft='<div style="float:left;">';
					$ukeyright='</div><div style="float:right; border-left:solid 1px #999999; width:200px; padding-left:10px;">';
					$ukeyright.=label('SEO tools',false);
					$ukeyright.='<hr/><br/>';
					$ukeyright.=label('Title (max 66)',false);
					$ukeyright.= '<div class="element"><input type="text" id="'.$diag_type.'_'.'ukey_title'.'_'.$type_name.'" name="ukey_title"  style="width:198px" value="" class="text_input" maxlength="66"/></div>';
					$ukeyright.=label('Description (max 420)',false);
					$ukeyright.= '<div class="element"><textarea id="'.$diag_type.'_'.'ukey_desc'.'_'.$type_name.'" name="ukey_desc" rows="5" cols="30" onchange="if(this.value.length>420){ this.value = this.value.substring(0,420); }" onkeypress="if(this.value.length>420){ this.value = this.value.substring(0,420); } return (this.value.length < 420);" class="text_input"></textarea></div>';
					$ukeyright.='<input type="hidden" name="ukeyseo" value="1" />';
					$ukeyright.='</div><div style="clear:both;"><!-- --></div>';
				}
                $onSubmit.=$element->onSubmit($diag_type.'_','_'.$type_name);
            }            
            if(strlen($onSubmit)>0) echo requiredNote();
           echo open_form($diag_type.'_'.$type_name,$onSubmit);
           echo $ukeyleft; 
           ?>
        <? foreach($this->elements as $element){ 
			$element->form_element($diag_type.'_','_'.$type_name,$row);
			}
			echo $ukeyright;
			?>
		<input type="hidden" name="submitUpdate" value="<?=$type_id?>" />
		<input type="hidden" name="PID" id="update_PID_<?=$type_name?>" value="" />
		<div style="margin-top:10px;"><input type="submit" value="Update" />&nbsp;<input type="button" value="Cancel" onClick="tb_remove();"/></div>
		<?=close_form();?>
		</div>
	<? }
	
	function update_js($postfix=null){?>
        function update<?=$postfix?>(PID<?
        $num = 15;
		foreach($this->elements as $element){
			if($element->column=='urlkeyword'&&$element->name=='Keyword'&&$_SESSION['advseo']){
				$num=255;
				$numheight=255;
			}
			echo ",".$element->action();
		} 
		if($num==255) echo ",ukey_title,ukey_desc";
		$height=63+($this->element_count()*28)+($this->element_count_height()*15);
		if($numheight>$height)$height=$numheight;
		       
        ?>){
            document.getElementById('update_PID_<?=$postfix?>').value=PID;   
            openID('update_cms_<?=$postfix?>',<?=$height?>,<?=justNum(mWidth($this->mWidth()))+$num?>); 
        <?
        foreach($this->elements as $element){	
			if($element->column=='urlkeyword'&&$element->name=='Keyword'&&$_SESSION['advseo']){
				?>
				document.getElementById('update_ukey_title_<?=$postfix?>').value=ukey_title;
                document.getElementById('update_ukey_desc_<?=$postfix?>').value=ukey_desc;
                <?
			}	
            $element->update_js($postfix);
        } ?>
            
        }
    <? }
	function element_count(){
		return count($this->elements);
	}
	function element_count_height(){
		$elementHeight=0;
		foreach($this->elements as $element){ 
			$elementHeight+=$element->get_element_height();
		}
		return $elementHeight;
	}
	function mWidth(){
		$mWidth=0;
        foreach($this->elements as $element){
				if($mWidth<$element->width)$mWidth=$element->width;
        }
		return $mWidth || $_SESSION['default_ms'];
	}
	function edit_action($postfix=null,$row){?>
        <input type="button" name="submitEdit" value="Edit" onClick="update<?=$postfix?>('<?=$row['id']?>'<?
        $ukey=0;
		foreach($this->elements as $element){
            if($element->column=='urlkeyword'&&$element->name=='Keyword'&&$_SESSION['advseo'])$ukey=$row['urlkeyword'];
			echo ",".$element->action($row);
        }
		if($ukey){
			$resultukey = mysql_query("SELECT * FROM cmsukeyseo WHERE ukey=".sqlFormat($ukey));
            $rowukey = @mysql_fetch_array($resultukey);			
			$order   = array("\r\n", "\n", "\r");
			$replace = array('\r\n','\n','\r');
			echo ","."'".str_replace($order, $replace, addslashes(htmlspecialchars($rowukey['seo_title'])))."'";
			echo ","."'".str_replace($order, $replace, addslashes(htmlspecialchars($rowukey['seo_desc'])))."'";
		}
        ?>);" /> 
	<? }
}
?>