<?
if((@include_once('types/declare_types.php')) === false)@include_once('../types/declare_types.php');
if((@include_once('types/CMS_Type.php')) === false)@include_once('../types/CMS_Type.php');

class CMS_Types_Page{
	
	var $exclude_cms_types;
	var $only_include;
	var $table;
	var $page_types;
	var $sub_page;
	var $name;
	var $alert;
	var $type_defs;
	var $toEnd=false;
	var $customTools='';
	var $customDB='';
	
	function setTypeDefs($type_defs){
		$this->type_defs=$type_defs;
	}
	function setup(){
		if($this->sub_page)if_not_create($this->table, $this->getDB().$this->customDB."fileid INT NOT NULL default 1,status INT NOT NULL default 0,type TEXT NULL, subpage TEXT NULL, groupid INT NOT NULL default 0, orderby INT NOT NULL default 0, tstamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, KEY orderby (orderby)");
		else if_not_create($this->table, $this->getDB().$this->customDB."fileid INT NOT NULL default 1,status INT NOT NULL default 0,type TEXT NULL, groupid INT NOT NULL default 0, orderby INT NOT NULL default 0, tstamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP, KEY orderby (orderby)");
	}
	function setName($name){
		$this->name=$name;
	}
	function setTable($table){
		$this->table=$table;
	}
	function setSubPage($spage){
		$this->sub_page=$spage;
	}
	function getSubPage(){
		return $this->sub_page;
	}	
	function setCustomTools($str){
		$this->customTools=$str;
	}
	function setCustomDB($str){
		$this->customDB=$str;
	}
	function exclude($types){
		$this->exclude_cms_types=$types;
	}
	function getDB(){
		$addDB = array();
		foreach($this->page_types as $type){
			$addDB = array_merge($addDB,$type->getDB());
		}
		$addDB = array_unique($addDB);
		return implode(",",$addDB).',';
	}
	
	function only($types){
		$this->only_include=$types;
	}

	function filter_types($filter=false){
		if($this->only_include){
			$outArray = explode(",",$this->only_include);
		}else{
			$current = explode(",",$_SESSION['current_cms_types']);
			$exclude = explode(",",$this->exclude_cms_types); 
			$outArray = array_diff($current,$exclude);
		}
		if($filter){
				foreach($outArray as $type){
					if(is_int($type))$tempArray[] = $type;
				}
				$outArray = $tempArray;
		}
		return $outArray;
	}
	
	function include_types(){
		$types=$this->filter_types();
		foreach($types as $typeIndex){
		if((@include_once('types/'.$this->type_defs[intval($typeIndex)].'.php')) === false)@include_once('../types/'.$this->type_defs[intval($typeIndex)].'.php');
		}
	}
	
	function submitAdd(){
		if($_POST['submitAdd']){
			if($_POST['ukeyseo']){
				mysql_query("REPLACE cmsukeyseo SET ukey=".sqlFormat($_POST['urlkeyword']).",seo_title=".sqlFormat($_POST['ukey_title']).",seo_desc=".sqlFormat($_POST['ukey_desc']));
				echo mysql_error();
				//update the ukeyseo table
			}
			$this->page_types[$_POST['submitAdd']]->addToEnd($this->toEnd);
			$this->page_types[$_POST['submitAdd']]->submitAdd($this->sub_page);
		}
	}
	
	function submitUpdate(){
		if($_POST['submitUpdate']&&$_POST['ukeyseo']){
			mysql_query("REPLACE cmsukeyseo SET ukey=".sqlFormat($_POST['urlkeyword']).",seo_title=".sqlFormat($_POST['ukey_title']).",seo_desc=".sqlFormat($_POST['ukey_desc']));
			echo mysql_error();
			//update the ukeyseo table
		}
		if($_POST['submitUpdate'])$this->page_types[$_POST['submitUpdate']]->submitUpdate();
		if($_POST['submitUpdate']!=$_POST['submitChange']&&isset($_POST['submitChange'])){
			sleep(.1);
			$this->processFile($_POST['PID'],$_POST['FID']);
		}
	}	
	
	function submitDelete(){
		if($_POST['submitDelete']&&$_POST['PID']){
			deleteFile($this->table,$_POST['PID']);
			if(!deleteOrdered($this->table,$_POST['PID'])) return "Delete Failed.";	
		}
	}
	
	function addNew_dialogs(){
		$options="";
		$imageNum=0;
		foreach($this->page_types as $type){
			if($type->image_type){
				$options.='<option value="'.$type->type_id.'">'.$type->name.'</option>';
				$imageNum++;
			}
		}
		if($imageNum<2)$options="";
		$cm2_image_type=false;
		foreach($this->page_types as $type){
			if($cm2_image_type&&$type->image_type)continue;
			if($type->image_type)$cm2_image_type=true;
			if($type->image_type&&$options){
				$type->addNew_dialog($options);
				$options="";
			}
			else $type->addNew_dialog();
		}
	}
	function addToEnd($bool=true){
		$this->toEnd=$bool;
	}
	function update_dialogs(){
		foreach($this->page_types as $type){
			$type->update_dialog();
		}
	}
	function addTypes(){
		$pgTypes = array();
		foreach($this->page_types as $type){
			if($type->canAdd)$pgTypes[] = $type;
		}
		if(count($pgTypes)>0){ 
			if(count($pgTypes)==1){ 
				foreach($pgTypes as $type){
					if($type->image_type){ ?>
					<div><form><input type="button" value="Add New" onClick="addNewImage();"/></form></div>
					<? } else { ?>
					<div><form><input type="button" value="Add New" onClick="addNew<?=$type->type_name;?>();"/></form></div>
			  <? } }
			  }else{ ?>
				<div><select name="select_type" id="select_type">
					<option value="">Content Type</option>
				<?	
					$cm2_image_type=false;
					foreach($pgTypes as $type){ 
						if($type->image_type){
							if(!$cm2_image_type) { ?>
							<option value="Image">Image</option>
							<? }
							$cm2_image_type=true;					
						} else {				?>
					<option value="<?=$type->type_name;?>"><?=$type->name;?></option>
				<? }} ?>
				</select>&nbsp;<input type="button" onClick="if(getElementById('select_type').value) addNew(getElementById('select_type').value)" value="Add"/></div>
			<? }}
	}
	function getTools(){
		echo $this->customTools;
		foreach($this->page_types as $type){
			if($type->showTools())$type->getTools();
		}
	}
	
	function dispTypes(){
		if(count($this->page_types)>1){
			foreach($this->page_types as $typeid=>$type){
				$this->page_types[$typeid]->displayType(true);
			}
		}
	}
	
	function get_js(){
		$cm2_image_type=false;
		foreach($this->page_types as $type){
			if($type->image_type){
				if(!$cm2_image_type) $type->get_js();
				$type->upload_js();
				$cm2_image_type=true;
             } else { 
				$type->get_js();
			 } } ?>
        function addNew(type_name){
        	<? foreach($this->page_types as $type){	?>
                if(type_name=='Image') addNewImage(); 
                else if(type_name=='<?=$type->type_name;?>') addNew<?=$type->type_name;?>();            
            <? } ?>
        }
        
        <?
	}	
	function write_type_content($row){
		$type = $this->page_types[$row['type']]->write_type_content($row);
	}
	function processFile($id,$fid){
		$result = @mysql_query("SELECT * FROM ".$this->table.",fileDB WHERE fid=fileid AND id=".sqlFormat($id)." AND fid=".sqlFormat($fid));
		$row = @mysql_fetch_array($result);
		if(!$row['error']){
			$status=2;
			@mysql_query("UPDATE ".$this->table." SET status=$status WHERE id=".$id);
		}
		$this->page_types[$row['type']]->processFile($id,$fid);
	}	
	function thumbnailer(){
			?>
        <div id="thumbnailer" class="addNew_cms" style="display:none;"><div id="thumbnailer_div"></div><?=open_form()?><div style="margin-top:10px;"><input type="submit" value="Done" /></div><?=close_form();?></div>
        <?
	}	
	function write_page(){ 
		$groupid=0;
		if($_POST['groupID'])$_GET['groupID']=$_POST['groupID'];
		if($_GET['groupID'])$groupid=$_GET['groupID'];
		$this->alert='';
		$this->include_types();
		$this->setup();
		$this->dispTypes();
		$this->thumbnailer();
		$this->submitAdd();
		$this->submitUpdate();
		$this->alert=$this->submitDelete();
		$this->addNew_dialogs();
		$this->update_dialogs();
		if($_GET['typeID']) $this->page_types[$_GET['typeID']]->write_sub();
		else {
	?>
            <div class="leftcol">
            <div class="content_bkg">
            <? if($groupid>0){ 
					echo '<div style="margin-bottom:10px; border-bottom:1px solid #c1c1c1;">';
					$result = @mysql_query("SELECT * FROM ".$this->table.",fileDB WHERE fid=fileid AND id=".sqlFormat($groupid)." ORDER BY orderby ASC");
					$row = @mysql_fetch_array($result);
					$parentID=$row['groupid'];
					echo title($row['text_content']);
					//CMS_Title::write_type($row);
					echo "</div>";
            	 } ?>
                <div id="sort_group">
                <?
				if($this->sub_page)$result = mysql_query("SELECT * FROM ".$this->table.",fileDB WHERE fid=fileid AND subpage=".sqlFormat($this->sub_page)." AND groupid=".sqlFormat($groupid)." ORDER BY orderby ASC");
                else $result = mysql_query("SELECT * FROM ".$this->table.",fileDB WHERE fid=fileid AND groupid=".sqlFormat($groupid)." ORDER BY orderby ASC");
                while ($row = @mysql_fetch_array($result)) {
                	$is_some=true;
					if($this->page_types[$row['type']])$this->page_types[$row['type']]->write_type($row);
                }
                if(!$is_some) echo '<div>'.title($this->name.' Empty').'</div>';
                ?>
                </div>
            </div>
          </div>
          <div class="rightcol">
           <div class="content_bkg"><?=$this->addTypes();?>
		   <? if($groupid>0){ ?><br/><?
		   if($parentID>0) echo back($parentID);
           else if($_GET['page_sub']&&$_GET['page_sub']!=1) echo back($groupid);
		   else echo back();?><? } ?></div>
           <?=$this->getTools();?>
          </div>
          <script type="text/javascript">
          // <![CDATA[

<?=$this->get_js();?>
<? if($this->alert) { ?>alert('<?=$this->alert;?>');<? } ?>
		  
          function updateOrder(container) {
                    var url = 'update/updateOrder.php';
                    var params = Sortable.serialize(container.id);
                    var ajax = new Ajax.Request(url,{
                        method: 'post',
                        parameters: { data: params, table: "<?=$this->table?>"<? if($_GET['groupID']){ ?>, groupID: "<?=$_GET['groupID']?>"<? } ?>},
                        onLoading: function(){Sortable.destroy('sort_group');},
                        onLoaded: function(){Sortable.create('sort_group',{tag:'div',onUpdate:updateOrder})}
                    });
                  
                }
          Sortable.create('sort_group',{tag:'div',onUpdate:updateOrder})
			function uploadUpdate(fid,id,pageid){
				if(pageid!=<?=$_GET['page']?>)return;
				var url = 'update/updateType.php';
				var ajax = new Ajax.Updater({ success: 'group_'+id },url,{
					method: 'post',
					parameters: { id: id, fid: fid, pageid: <?=$_GET['page']?>, table: "<?=$this->table?>"}
				});
				if(typeof(writeVideoPlayer) == "function")  writeVideoPlayer();
				if(typeof(writeAudioPlayer) == "function")  writeAudioPlayer();
			}  
            function updateStatus(container,id) {
                    var url = 'update/updateStatus.php';
                    var ajax = new Ajax.Request(url,{
                        method: 'post',
                        parameters: { id: id, status: container.value, table: "<?=$this->table?>"},
                        onLoading: function(){container.disabled=true},
                        onLoaded: function(){container.disabled=false}
                    });
                  
                }
			 function updateWrap(container,id) {
                    var url = 'update/updateWrap.php';
                    var ajax = new Ajax.Request(url,{
                        method: 'post',
                        parameters: { id: id, status: container.checked, table: "<?=$this->table?>"},
                        onLoading: function(){container.disabled=true},
                        onLoaded: function(){container.disabled=false}
                    });
                  
                }
			function thumbnailer(fid,id,w,h,pfix){
				openID('thumbnailer',585,1000);
				var flashvars = {
					thumbX: w,
					thumbY: h
				};
				flashvars.thePic = "../../FDB/"+fid+".jpg";
				if(pfix)flashvars.theThumb= "../../FDB/"+fid+"_"+pfix+".jpg";
				else flashvars.theThumb= "../../FDB/"+fid+"_thumb.jpg";
				var params = {
				  menu: "false",
				  wmode: "transparent",
				  scale: "noscale",
				  base: "tools/",
				  salign: "TL"
				};
				var attributes = {};
				swfobject.embedSWF("tools/thumbnailer.swf", "thumbnailer_div", "1000", "550", "8.0.0", false, flashvars, params, attributes);
			}

          // ]]>
        </script>
    
    <? }}

}

$types_page = new CMS_Types_Page();
$types_page->setTypeDefs($cms_type);


?>


  