<?php
	if((@include_once('cm2/functions.php')) === false)@include_once('../cm2/functions.php');
	if((@include_once('cm2/config/config.php')) === false)@include_once('../cm2/config/config.php');
	if((@include_once('cm2/types/declare_types.php')) === false)@include_once('../cm2/types/declare_types.php');	
	
	function tour_item($rowT, $id='', $class=''){
		echo '<div id="'.$id.'" class="item '.$class.' tourItem">';
		echo '<div class="head">'.date('m.d.y',$rowT['date']);
		if($rowT['city'] || $rowT['state']) echo '  |  ';
		if($rowT['city']) echo $rowT['city'];
		if($rowT['city'] && $rowT['state']) echo ', ';
		if($rowT['state']) echo $rowT['state'];
		if($rowT['time']) echo '  |  '.$rowT['time'];
		echo '</div>';
		if($rowT['venue']||$rowT['cost']){
			echo '<div class="venue">';
			if($rowT['venueurl']) echo '<a href="'.$rowT['venueurl_protocol'].$rowT['venueurl'].'" target="_blank">';
			else if($rowT['address']||$rowT['zip']){
				$venue= '<a href="http://maps.google.com/maps?f=q&hl=en&q=';
				$venueA='';
				if($rowT['address'])$venueA.=$rowT['address'].', ';
				if($rowT['city'])$venueA.=$rowT['city'].', ';
				if($rowT['state'])$venueA.=$rowT['state'].', ';
				if($rowT['zip'])$venueA.=$rowT['zip'];
				$venue.=urlencode($venueA).'" target="_blank">';
				echo $venue;
			}
			if($rowT['venue'])echo $rowT['venue'];
			if($rowT['venueurl']||$rowT['address']||$rowT['zip']) echo '</a>';
			if($rowT['venue']&&$rowT['cost']) echo ' - ';
			if($rowT['cost']) echo $rowT['cost'];
			echo '</div>';
		}
		echo '<div class="info">'.htmlFormat($rowT['info']).'</div>';
		echo '</div>';
	}
		
	function htmlFormat($str) {
		$repl = array('<a ','<a target="_blank" href="mailto','<a target="_blank" href="CM2_Keyword:','<a target="_blank" href="CM2_Email:',"\r\n","<bold>","</bold>","<ital>","</ital>","<t>","</t>","<grey>","</grey>");
		$withthis = array('<a target="_blank" ','<a target="_self" href="mailto','<A href="/','<a href="mailto:',"<br>","<b>","</b>","<i>","</i>",'<span class="h2">',"</span>",'<span style="color:#999;">',"</span>");
		return utf8_encode(str_replace($repl,$withthis,$str));
	}
	
	function echoItem($htmlTxt, $total=0, $prefix="cID"){
		echo $prefix.$total++.'='.FlashFormat::format($htmlTxt,false).'&';
		return $total;
	}
	function echoAttrib($name,$val,$total=0,$prefix="cID"){
		echo $prefix.$total.'_'.$name.'='.FlashFormat::format($val,false).'&';
	}

	function processSideHTML($resultsSide, $status, $resource, $wrapWidth=0, $currentTxt=""){
		$str='';
		$currentTxt="";		
		$altImage="clearfix";
		$cnt=0;
		while ($rowSide = @mysql_fetch_array($resultsSide)) {
			if($rowSide['type']!=BODY_TYPE&&$rowSide['type']!="item"&&$rowSide['type']!=THUMBNAIL_IMAGE_TYPE_POPUP&&$rowSide['type']!=THUMBNAIL_IMAGE_TYPE&&$currentTxt){
				echo htmlFormat('<div class="spanel"><div class="clearfix">'.$currentTxt.'<div style="clear:both"></div></div></div>');
				$currentTxt="";
			}
			if($rowSide['type']!="item"&&$rowSide['type']!=THUMBNAIL_IMAGE_TYPE_POPUP&&$rowSide['type']!=THUMBNAIL_IMAGE_TYPE)$altImage="clearfix";
			switch($rowSide['type']){			
				case 'html':
					echo '<div class="space embed clearfix">'.$rowSide['text_content'].'</div>';
				break;
				case 'album':
?>					<div id="tw-feed">
						<div class="spanel side-content album">
							<div>
<?php if((@include_once('cm2_scripts/_album.php')) === false)@include_once('_album.php'); ?>									
							</div>
						</div>
					</div>
<?php				break;
				case '1':
?>					<div id="tw-feed">
						<div class="spanel side-content twit">
							<h2>Twitter</h2>
							<div>				
<?php if((@include_once('cm2_scripts/_twitter.php')) === false)@include_once('_twitter.php'); ?>						
							</div>
						</div>
					</div>
<?php					break;
				case THUMBNAIL_IMAGE_TYPE:
					$img="FDB/".$rowSide['fid']."_thumb.jpg";
					if($altImage=="clearfix") $currentTxt.='<div class="clear"><!-- --></div>';
					$currentTxt.= '<div class="img '.$altImage.'"><img src="/'.$img.'?c='.$rowSide['cache'].'" alt="'.htmlentities($rowSide['text_content']).'"></div>';
					if($altImage=="even"){
						$currentTxt.='<div class="clear"><!-- --></div>';
						$altImage="clearfix";
					}
					else $altImage="even";	
					break;	
				case THUMBNAIL_IMAGE_TYPE_POPUP:
					$img="FDB/".$rowSide['fid']."_thumb.jpg";
					if($altImage=="clearfix") $currentTxt.='<div class="clear"><!-- --></div>';
					$currentTxt.= '<div class="img '.$altImage.'"><a href="/FDB/'.$rowSide['fid'].'_large.jpg?c='.$rowSide['cache'].'" rel="lightbox"><img src="/'.$img.'?c='.$rowSide['cache'].'" alt="'.htmlentities($rowSide['text_content']).'"></a></div>';
					if($altImage=="even"){
						$currentTxt.='<div class="clear"><!-- --></div>';
						$altImage="clearfix";
					}
					else $altImage="even";
					break;	
				case FULL_WIDTH_IMAGE_TYPE:
					$img="FDB/".$rowSide['fid']."_large.jpg";
					if(file_exists($img)){
						$size = GetImageSize($img);
						$w=$size[0];
					}
					echo htmlFormat('<div class="spanel"><div class="img"><img src="/'.$img.'?c='.$rowSide['cache'].'" width="'.$w.'" alt="'.htmlentities($rowSide['text_content']).'"></div></div>');
					break;
				case LINK_IMAGE_TYPE:
					$img="FDB/".$rowSide['fid']."_large.jpg";
					if(file_exists($img)){
						$size = GetImageSize($img);
						$w=$size[0];
					}
					$target='_blank';
					if($rowSide['text_content_protocol']=='CM2_Keyword:'||$rowSide['text_content_protocol']=='mailto:')$target='_self';	
				
					echo htmlFormat('<div class="spanel"><div class="img"><a href="'.$rowSide['text_content_protocol'].$rowSide['text_content'].'" target="'.$target.'"><img src="/'.$img."?c=".$rowSide['cache'].'" width="'.$w.'" alt="'.htmlentities($rowSide['text_content']).'"></a></div></div>');
					break;	
			}
			$cnt++;
		
		}
		if($currentTxt){
			echo htmlFormat('<div class="spanel"><div class="clearfix">'.$currentTxt.'<div style="clear:both"></div></div></div>');
		}
	}

		
	
	function processHTML($results, $wrapWidth=0, $currentTxt=""){
		$str='';
		$currentTxt="";		
		$altImage="clearfix";
		$cnt=0;
		while ($row = @mysql_fetch_array($results)) {
			if($row['type']!=BODY_TYPE&&$row['type']!="item"&&$row['type']!=THUMBNAIL_IMAGE_TYPE_POPUP&&$row['type']!=THUMBNAIL_IMAGE_TYPE&&$currentTxt){
				$str.='<div class="clearfix">'.$currentTxt.'<div style="clear:both"></div></div>';
				$currentTxt="";
			}
			if($row['type']!="item"&&$row['type']!=THUMBNAIL_IMAGE_TYPE_POPUP&&$row['type']!=THUMBNAIL_IMAGE_TYPE)$altImage="clearfix";
			switch($row['type']){
				case 'html':
					echo '<div class="space embed clearfix">'.$row['text_content'].'</div>';
				break;
				case 'readmore':
						$str.='<A href="/news/entries/'.$row['groupid'].'" class="button readmore">Read More</A>';
					break;		
				case 'item':					
					$img="FDB/".$row['fid']."_thumb.jpg";
					if($altImage=="clearfix") $currentTxt.='<div class="clear"><!-- --></div>';
					if($row['text_content'])$currentTxt.= '<div class="img '.$altImage.'" ><div><div><a href="/FDB/'.$row['fid'].'_large.jpg?c='.$row['cache'].'" rel="lightbox"><img src="/'.$img.'?c='.$row['cache'].'" style="border:0;" alt="'.htmlentities($row['text_content']).'"></a><br/>'.htmlFormat($row['text_content']).'</div></div></div>';
					else $currentTxt.= '<div class="img '.$altImage.'" ><div><div><a href="/FDB/'.$row['fid'].'_large.jpg?c='.$row['cache'].'" rel="lightbox"><img src="/'.$img.'?c='.$row['cache'].'" style="border:0;" alt="'.htmlentities($row['text_content']).'"></a></div></div></div>';
					if($altImage=="even"){
						$currentTxt.='<div class="clear"><!-- --></div>';
						$altImage="clearfix";
					}
					else $altImage="even";
					break;
				case AUDIO_SUB_TYPE:
					$str.= '<div class="clearfix audiodiv"><h3 class="audio">';
					if($row['text_content_protocol'])$str.='<A href="'.$_SESSION['curkey'].'/'.strtolower($row['urlkeyword']).'">';
					$str.=htmlFormat($row['text_content']);
					if($row['text_content_protocol'])$str.='</A>';
					$str.='</h3>';
					$str.= '<a class="fade-link mp3" name="'.htmlentities($row['text_content']).'" data-mp3="'.$row['fid'].'"><img src="/images/audio.png" style="margin:3px;"/></a></div>';

					break;
				case 'track':
					$str.= '<div class="clearfix audiodiv"><h3 class="audio">';
					if($row['text_content_protocol'])$str.='<A href="'.$_SESSION['curkey'].'/'.strtolower($row['urlkeyword']).'#content">';
					$str.=htmlFormat($row['text_content']);
					if($row['text_content_protocol'])$str.='</A>';
					$str.='</h3></div>';
					break;
				case 'header':
					if($str)$str.='</div><div class="cont'.$cnt.'">';
					$str.= '<style> .cont'.$cnt.' a, .cont'.$cnt.' h1{ color:'.$row['text_content_protocol'].'; } .content section > header.cont'.$cnt.', .content section > div.cont'.$cnt.'{ border-color:'.$row['text_content_protocol'].'; } section header.cont'.$cnt.' .icon{ background-color:'.$row['text_content_protocol'].'; } </style>';
					$str.= '<header class="cont'.$cnt.'"><div class="icon"><span></span></div> <div class="title"><h1>'.htmlFormat($row['text_content']).'</h1></div><div style="clear:both;"><!-- --></div></header>';
					break;
				case TITLE_TYPE:  //1
					$str.= '<div><h2 class="title">'.htmlFormat($row['text_content']).'</h2></div>';
					break;
				
				case BODY_TYPE:  //2
					$currentTxt.= htmlFormat('<p>'.$row['text_content'].'</p>');
					break;
				
				case BODY_NOWRAP_TYPE:  //2
					$str.="<div>".htmlFormat('<p>'.$row['text_content'].'</p>').'<div style="clear:both"></div></div>';
					break;
				case 'div':
				case 'divider':  //2
					$str.='<div class="hr"></div>';
					break;
						
				case BANNER_IMAGE_TYPE:  //11  deprecated	
					$img="FDB/".$row['fid']."_thumb.jpg";
					if(file_exists($img)){
						$size = GetImageSize($img);
						$w=$size[0];
					}
					$str.= '<div style="text-align:center;" class="img"><img src="/'.$img.'?c='.$row['cache'].'" width="'.$w.'" alt="'.htmlentities($row['text_content']).'"></div>';
					break;							
				case THUMBNAIL_IMAGE_TYPE:  //3
					$img="FDB/".$row['fid']."_thumb.jpg";
					if($altImage=="clearfix") $currentTxt.='<div class="clear"><!-- --></div>';
					$currentTxt.= '<div class="img '.$altImage.'"><img src="/'.$img.'?c='.$row['cache'].'" alt="'.htmlentities($row['text_content']).'"></div>';
					if($altImage=="even"){
						$currentTxt.='<div class="clear"><!-- --></div>';
						$altImage="clearfix";
					}
					else $altImage="even";					
					break;
				case THUMBNAIL_IMAGE_TYPE_POPUP: 
					$img="FDB/".$row['fid']."_thumb.jpg";
					if($altImage=="clearfix") $currentTxt.='<div class="clear"><!-- --></div>';
					$currentTxt.= '<div class="img '.$altImage.'"><a href="/FDB/'.$row['fid'].'_large.jpg?c='.$row['cache'].'" rel="lightbox"><img src="/'.$img.'?c='.$row['cache'].'" alt="'.htmlentities($row['text_content']).'"></a></div>';
					if($altImage=="even"){
						$currentTxt.='<div class="clear"><!-- --></div>';
						$altImage="clearfix";
					}
					else $altImage="even";
					break;

				case RESIZE_IMAGE_TYPE:  //18					
				case FULL_HEIGHT_IMAGE_TYPE:  //14				
				case FULL_WIDTH_IMAGE_TYPE:  //4
				case SIZE_TO_FIT_IMAGE_TYPE:  //6	
				case FULL_WIDTH_IMAGE_TYPE_POPUP:  //8
				case SIZE_TO_FIT_IMAGE_TYPE_POPUP:  //9								
					$img="FDB/".$row['fid']."_large.jpg";
					if(file_exists($img)){
						$size = GetImageSize($img);
						$w=$size[0];
					}
					if($w<($_SESSION['default_width']*0.66))$currentTxt='<div class="img"><img src="/'.$img.'?c='.$row['cache'].'" width="'.$w.'" alt="'.htmlentities($row['text_content']).'"></div>';
					else $str.= '<div class="img"><img src="/'.$img.'?c='.$row['cache'].'" width="'.$w.'" alt="'.htmlentities($row['text_content']).'"></div>';
					break;
				case LINK_TYPE:
					$target='_blank';
					if($row['text_content_protocol']=='CM2_Email:'||$row['text_content_protocol']=='CM2_Keyword:'||$row['text_content_protocol']=='mailto:')$target='_self';	
					
						$str.= "<div>".htmlFormat('<h2><a href="'.$row['text_content_protocol'].$row['text_content'].'" target="'.$target.'">'.$row['link_text_content'])."</a></h2></div>";
					break;
				case LINK_IMAGE_TYPE:  //19
					$img="FDB/".$row['fid']."_large.jpg";
					if(file_exists($img)){
						$size = GetImageSize($img);
						$w=$size[0];
					}
					$target='_blank';
					if($row['text_content_protocol']=='CM2_Keyword:'||$row['text_content_protocol']=='mailto:')$target='_self';	
				
					if($w<($_SESSION['default_width']*0.66))$currentTxt=htmlFormat('<div class="img"><a href="'.$row['text_content_protocol'].$row['text_content'].'" target="'.$target.'">').'<img src="/'.$img."?c=".$row['cache'].'" width="'.$w.'" alt="'.htmlentities($row['text_content']).'"></a></div>';
					
					else $str.= '<div style="text-align:center;" class="img">'.htmlFormat('<a href="'.$row['text_content_protocol'].$row['text_content'].'" target="'.$target.'">').'<img src="/'.$img."?c=".$row['cache'].'" width="'.$w.'" alt="'.htmlentities($row['text_content']).'"></a></div>';

					break;
				case YOUTUBE_TYPE:
					$nowW=intval($_SESSION['default_width']);
					$nowH=floor($nowW/16*10)+15;
					if(stripos($row['text_content'],'imeo')){ 
						$currentTxt= '<div class="space"><iframe src="http://player.vimeo.com/video/'.parseYouTube($row['text_content'],true).'?title=0&amp;byline=0&amp;portrait=0&amp;color=ffffff" width="'.$nowW.'" height="'.$nowH.'" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe></div>';
					 } else { 
						$currentTxt= '<div class="space"><iframe width="'.$nowW.'" height="'.$nowH.'" src="http://www.youtube.com/embed/'.parseYouTube($row['text_content'],true).'?modestbranding=1&showinfo=0&html5=1" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowfullscreen></iframe></div>';
					 }
					break;
				case EMBED_TYPE:
					if($row['text_content_protocol']||$row['urlkeyword']){
						$embW=(intval($_SESSION['default_width']))? intval($_SESSION['default_width']) : intval($row['ext']);
						$embH=(intval($row['urlkeyword']))? intval($row['urlkeyword']) : intval($row['ext']);
						$scrolling="";
						if($row['cache'])$scrolling='scrolling="no"';
						$str.='<div class="space">'.'<iframe style="width:'.$embW.'px; height:'.$embH.'px; border:0" frameBorder="0" src="/cm2_iframe.php?fid='.$row['fid'].'" '.$scrolling.'></iframe>'.'<div style="clear:both"></div></div>';
					} else {
						$str.='<div class="space">'.$row['originalname'].'<div style="clear:both"></div></div>';
					}
				
					break;		
			}
			$cnt++;
		
		}
		if($currentTxt){
			$str.='<div class="clearfix">'.$currentTxt.'<div style="clear:both"></div></div>';
		}
		return htmlFormat($str);
	}
?>